<script setup lang="ts">
  const stylingMapping = {
    default: 'border-0 shadow-none hover:underline focus:underline cursor-pointer',
    action: {
      default: 'text-primary hover:text-primary-hover focus:text-primary-pressed',
      disabled:
        '!text-primary-disabled pointer-events-none cursor-not-allowed hover:no-underline focus:no-underline',
    },
    primary: {
      default: 'text-primary hover:text-primary-hover focus:text-primary-pressed',
      disabled:
        '!text-primary-disabled pointer-events-none cursor-not-allowed hover:no-underline focus:no-underline',
    },
    danger: {
      default: 'text-crimson-500 hover:text-crimson-700 focus:text-crimson-900',
      disabled:
        '!text-crimson-200 pointer-events-none cursor-not-allowed hover:no-underline focus:no-underline',
    },
  };

  const props = withDefaults(
    defineProps<{
      variant?: 'action' | 'primary' | 'danger';
      to?: string;
      disabled?: boolean;
    }>(),
    {
      variant: 'primary',
    },
  );

  const computedClasses = computed(() => {
    return `${stylingMapping.default} ${stylingMapping[props.variant].default} ${
      props.disabled ? stylingMapping[props.variant].disabled : ''
    }`;
  });
</script>

<template>
  <NuxtLink v-if="to" :to="to" :class="computedClasses">
    <slot />
  </NuxtLink>
  <button v-else :class="computedClasses">
    <slot />
  </button>
</template>
